// Copyright 2001, 2002  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.

#ifndef OLENA_VALUE_ALL_HH
# define OLENA_VALUE_ALL_HH

#if (defined __GNUC__) && (__GNUC__ < 3) && HAVE_STL_CONFIG_H
#  include <stl_config.h>
#  undef __STL_BEGIN_RELOPS_NAMESPACE
#  define __STL_BEGIN_RELOPS_NAMESPACE namespace rel_ops {
#  undef __STL_END_RELOPS_NAMESPACE
#  define __STL_END_RELOPS_NAMESPACE }
#endif


# include <oln/types/type.hh>

# include <oln/types/to_oln.hh>
# include <oln/types/predecls.hh>

# include <oln/types/builtins_properties.hh>

# include <oln/types/rec_value.hh>

# include <oln/types/behaviour.hh>
# include <oln/types/interval.hh>

# include <oln/types/typetraits.hh>
# include <oln/types/typetraits_builtins_int.hh>
# include <oln/types/typetraits_builtins_float.hh>

# include <oln/types/optraits.hh>

# include <oln/types/int_u.hh>
# include <oln/types/int_s.hh>
# include <oln/types/range.hh>
# include <oln/types/cycle.hh>
# include <oln/types/bin.hh>

# include <oln/types/optraits_int_u.hh>
# include <oln/types/optraits_int_s.hh>
# include <oln/types/optraits_range.hh>
# include <oln/types/optraits_cycle.hh>
# include <oln/types/optraits_builtins_int.hh>
# include <oln/types/optraits_builtins_float.hh>
# include <oln/types/optraits_bin.hh>

# include <oln/types/global_ops_traits.hh>
# include <oln/types/global_ops.hh>

#endif // ndef OLENA_VALUE_ALL_HH
